﻿/////////////////////////////////////////////////////////////////////////////////////
//                                                                                 //
//  Volume Control Gadget 1.2 by Orbmu2k © 2007                                   //
//                                                                                 //
//  Copyright © 2007 Orbmu2k.  All rights reserved.                                //
//                                                                                 //
//  http://blog.orbmu2k.de                                                         //
//                                                                                 //
//  Email: sidebargadget@orbmu2k.de                                                //
//                                                                                 //
/////////////////////////////////////////////////////////////////////////////////////

System.Gadget.settingsUI = "settings.html";
System.Gadget.onSettingsClosed = onSettingsClosed;

var sound;
var t;
var vol;
var mute;
var imgSpeaker;
var imgCross;
var txt;
var updating = false;

function init()
{
    sound = GetLibrary();
    loadSettings();
    initObjects();
	t = setInterval("refreshdisplay()",75);
}

function loadSettings()
{
    var b = System.Gadget.Settings.readString("background");
    if (b != "") background.src = b;

    if (b == "background.png" || b == "")
        win10back.style.display = "block";
    else
        win10back.style.display = "none";
}

function onSettingsClosed()
{
    loadSettings();
}

function terminate()
{
    UnregisterLibrary();
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//Two small functions to make gadgets high-dpi compatible by the author of 8GadgetPack  (Version 1)
//Include this if you use addTextObject or addImageObject.
//You also have to wrap fixDpiObject around every call to one of those functions.
//For example replace "g.addTextObject(...)" with "fixDpiObject(g.addTextObject(...))"
////////////////////////////////////////////////////////////////////////////////////////////////////
function getDpiScaling() {
    var wshShell = new ActiveXObject("WScript.Shell");
    var DPI = 96;
    try {
        try {
            //You can set custom DPI in 8GadgetPack
            DPI = wshShell.RegRead("HKCU\\Software\\8GadgetPack\\ForceDPI");
        }
        catch (e) {
            //In case no custom DPI is set or 8GadgetPack isn't installed
            DPI = wshShell.RegRead("HKCU\\Control Panel\\Desktop\\LogPixels");
        }
        wshShell.RegRead("HKCU\\Software\\8GadgetPack\\NoGadgetScalingFix"); //In case I'll be able to fix this in sidebar.exe I will set this registry entry
        DPI = 96;
    }
    catch (e) { }
    return parseInt((DPI / 96) * 100) / 100;
}
var dpiScaling = getDpiScaling();
function fixDpiObject(obj) {
    if ("fontsize" in obj) {
        obj.left = obj.left * dpiScaling;
        obj.top = obj.top * dpiScaling;
    }
    else {
        obj.left = obj.left * dpiScaling + (obj.width * dpiScaling - obj.width) / 2;
        obj.top = obj.top * dpiScaling + (obj.height * dpiScaling - obj.height) / 2;
    }
    obj.width = obj.width * dpiScaling;
    obj.height = obj.height * dpiScaling;
    return obj;
}
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////

function initObjects()
{
    imgSpeaker = fixDpiObject(background.addImageObject("kmix.png", 4, 6));
    imgSpeaker.width = 24 * dpiScaling;
    imgSpeaker.height = 24 * dpiScaling;

    imgCross = fixDpiObject(background.addImageObject("cross.png", 18, 22));
    imgCross.width = 12 * dpiScaling;
    imgCross.height = 12 * dpiScaling;

    txt = fixDpiObject(background.addTextObject("", "arial", 11 * dpiScaling, "white", 31, 6));
}

function changeVolume()
{
    var v = sound.MasterVolume;

    if (event.wheelDelta >= 20)
		v += 3;
	else 
		v -= 3;
	
	if (v >= 100) v = 100;
	if (v <= 0) v = 0;

	sound.MasterVolume = v;
}

function muteVolume()
{
    if (event.button == 4)
    {                
        sound.MasterMute = !sound.MasterMute;
    }
    onMouseMove();
}

function onMouseMove()
{
    if (event.button == 1)
    {
        var v = event.x-12;
	    if (v >= 100) v = 100;
	    if (v <= 0) v = 0;
        sound.MasterVolume = v;
    }
}

function runMixer()
{
    System.Shell.execute("sndvol.exe");
}

function refreshdisplay()
{
    try
    {
        if (!System.Gadget.visible || updating) return;
        updating = true;
        
        vol = sound.MasterVolume;
        mute = sound.MasterMute;
        
        imgCross.opacity = mute ? 100 : 0;
        /*if (mute)
            txtVolume.innerText = "Volume: Mute";
        else
            txtVolume.innerText = "Volume: " + vol + "%";*/
        if (mute)
            txt.value = "Volume: Mute";
        else
            txt.value = "Volume: " + vol + "%";
        
        divvol.style.width = (Math.round((vol / 8)) * 8);
        divpeakleft.style.width = (Math.round((sound.LeftPeak / 4)) * 4);
        divpeakright.style.width = (Math.round((sound.RightPeak / 4)) * 4);
        
        updating = false;
    }
    catch(err) 
    {
    }
}

